/*
 * msp_WonderMV.c
 *
 *  Created on: Jan 13, 2025
 *      Author: 13752
 */


#include "MSP/msp_WonderMV.h"


SP_MSP_WonderMV_parameters* WonderMV_K210;
UART_HandleTypeDef* Huart_WonderMV_K210;

uint8_t WonderMV_FrameHeader[2];
uint8_t LenghAndXY[6];
uint8_t Mondermv_direction[2];
uint8_t MonderMV_offset[2];
uint8_t MonderMV_crc[1];
uint8_t receive_flag = 0;
uint8_t MonderMV_data[10];
uint8_t crc_cheak = 0;

uint8_t crc8_table[256] = {
	0, 94, 188, 226, 97, 63, 221, 131, 194, 156, 126, 32, 163, 253, 31, 65,
    157, 195, 33, 127, 252, 162, 64, 30, 95, 1, 227, 189, 62, 96, 130, 220,
    35, 125, 159, 193, 66, 28, 254, 160, 225, 191, 93, 3, 128, 222, 60, 98,
    190, 224, 2, 92, 223, 129, 99, 61, 124, 34, 192, 158, 29, 67, 161, 255,
    70, 24, 250, 164, 39, 121, 155, 197, 132, 218, 56, 102, 229, 187, 89, 7,
    219, 133, 103, 57, 186, 228, 6, 88, 25, 71, 165, 251, 120, 38, 196, 154,
    101, 59, 217, 135, 4, 90, 184, 230, 167, 249, 27, 69, 198, 152, 122, 36,
    248, 166, 68, 26, 153, 199, 37, 123, 58, 100, 134, 216, 91, 5, 231, 185,
    140, 210, 48, 110, 237, 179, 81, 15, 78, 16, 242, 172, 47, 113, 147, 205,
    17, 79, 173, 243, 112, 46, 204, 146, 211, 141, 111, 49, 178, 236, 14, 80,
    175, 241, 19, 77, 206, 144, 114, 44, 109, 51, 209, 143, 12, 82, 176, 238,
    50, 108, 142, 208, 83, 13, 239, 177, 240, 174, 76, 18, 145, 207, 45, 115,
    202, 148, 118, 40, 171, 245, 23, 73, 8, 86, 180, 234, 105, 55, 213, 139,
    87, 9, 235, 181, 54, 104, 138, 212, 149, 203, 41, 119, 244, 170, 72, 22,
    233, 183, 85, 11, 136, 214, 52, 106, 43, 117, 151, 201, 74, 20, 246, 168,
    116, 42, 200, 150, 21, 75, 169, 247, 182, 232, 10, 84, 215, 137, 107, 53
};


void GF_WonderMV_Unscramble_Callback();

uint8_t GF_MSP_WonderMV_Init(UART_HandleTypeDef* huart,SP_MSP_WonderMV_parameters* _WonderMV_K210)
{
	Huart_WonderMV_K210 = huart;
	GF_BSP_Interrupt_Add_CallBack(DF_BSP_InterCall_RS485_2_RxCpltCallback, GF_WonderMV_Unscramble_Callback);
	HAL_UART_Receive_IT(Huart_WonderMV_K210,WonderMV_FrameHeader,1);
	WonderMV_K210 = _WonderMV_K210;
	return 1;
}

void GF_WonderMV_Unscramble_Callback()
{
	switch(receive_flag)
	{
		case 0:
		if(WonderMV_FrameHeader[0] == 0xAA)
		{
			HAL_UART_Receive_IT(Huart_WonderMV_K210,WonderMV_FrameHeader,1);
			receive_flag = 1;
		}
		else {
			HAL_UART_Receive_IT(Huart_WonderMV_K210,WonderMV_FrameHeader,1);
			receive_flag = 0;
		}
		break;
		case 1:
			if(WonderMV_FrameHeader[0] == 0x55)
			{
				HAL_UART_Receive_IT(Huart_WonderMV_K210,LenghAndXY,6);
				receive_flag = 2;
			}
			else{
				HAL_UART_Receive_IT(Huart_WonderMV_K210,WonderMV_FrameHeader,1);
				receive_flag = 0;
			}
		break;
		case 2:
			HAL_UART_Receive_IT(Huart_WonderMV_K210,Mondermv_direction,2);
			receive_flag = 3;
		break;
		case 3:
			HAL_UART_Receive_IT(Huart_WonderMV_K210,MonderMV_offset,2);
			receive_flag = 4;
		break;
		case 4:
			HAL_UART_Receive_IT(Huart_WonderMV_K210,MonderMV_crc,1);
			receive_flag = 5;
		break;
		case 5:

			Array_joint();
			crc_cheak = CRC8_MAXIM(MonderMV_data,10);

			if(crc_cheak == MonderMV_crc)
			{
				MonderMV_Command_Comp();
				receive_flag = 1;
			}
			else {
				receive_flag = 1;
			}
			HAL_UART_Receive_IT(Huart_WonderMV_K210,WonderMV_FrameHeader,1);
		break;
	}
}

void Array_joint()
{
	for(int i = 0;i < 6;i ++)
	{
		MonderMV_data[i] = LenghAndXY[i];
	}
	for(int i = 0;i < 2;i ++)
	{
		MonderMV_data[i+6] = Mondermv_direction[i];
	}
	for(int i = 0;i < 2;i ++)
	{
		MonderMV_data[i+8] = MonderMV_offset[i];
	}
}

int CRC8_MAXIM(int *data,int datalen)
{
	uint8_t check = 0;

	for(int i=0;i<datalen;i++)
	{
        check = crc8_table[check ^ data[i]];
	}
	return check;
}

void MonderMV_Command_Comp()
{
	int result_direction = (Mondermv_direction[1] << 8) + Mondermv_direction[0];
	int result_offset = (MonderMV_offset[1] << 8) + MonderMV_offset[0];

	switch(result_direction & 0x8000)
	{
	    case 0:
	    	WonderMV_K210->Direction = result_direction;
	    break;
	    case 0x8000:
	    	result_direction = result_direction - 0xFFFF - 1;
	        WonderMV_K210->Direction = result_direction;
	    break;
	}
	switch(result_offset & 0x8000)
	{
    	case 0:
    		WonderMV_K210->Offset = result_offset;
    	break;
    	case 1:
    		result_offset = result_offset - 0xFFFF - 1;
    		WonderMV_K210->Offset = result_offset;
    	break;
	}
}

